searchData={"items":[{"type":"module","title":"Beacon.LiveAdmin","doc":"Beacon LiveAdmin is a Phoenix LiveView web application to manage Beacon sites.","ref":"Beacon.LiveAdmin.html"},{"type":"function","title":"Beacon.LiveAdmin.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Beacon.LiveAdmin.html#child_spec/1"},{"type":"function","title":"Beacon.LiveAdmin.start_link/1","doc":"Starts Beacon LiveAdmin's instances.","ref":"Beacon.LiveAdmin.html#start_link/1"},{"type":"module","title":"Beacon.LiveAdmin.Config","doc":"Configuration for Admin instances.\n\nSee `new/1` for available options and examples.","ref":"Beacon.LiveAdmin.Config.html"},{"type":"function","title":"Beacon.LiveAdmin.Config.fetch!/1","doc":"Returns the `Beacon.LiveAdmin.Config` for instance `name`.","ref":"Beacon.LiveAdmin.Config.html#fetch!/1"},{"type":"type","title":"Beacon.LiveAdmin.Config.name/0","doc":"Name to identify an Admin instance.","ref":"Beacon.LiveAdmin.Config.html#t:name/0"},{"type":"function","title":"Beacon.LiveAdmin.Config.new/1","doc":"Build a new `%Beacon.LiveAdmin.Config{}` to hold the entire configuration for each Admin instance.","ref":"Beacon.LiveAdmin.Config.html#new/1"},{"type":"function","title":"Options - Beacon.LiveAdmin.Config.new/1","doc":"* `:site` - `t:name/0` (required). Name of the Admin instance, must be unique. Defaults to `:admin`.","ref":"Beacon.LiveAdmin.Config.html#new/1-options"},{"type":"function","title":"Example - Beacon.LiveAdmin.Config.new/1","doc":"iex> Beacon.LiveAdmin.Config.new(\n      name: :my_admin\n    )\n    %Beacon.LiveAdmin.Config{\n      name: :my_admin\n    }","ref":"Beacon.LiveAdmin.Config.html#new/1-example"},{"type":"type","title":"Beacon.LiveAdmin.Config.option/0","doc":"","ref":"Beacon.LiveAdmin.Config.html#t:option/0"},{"type":"type","title":"Beacon.LiveAdmin.Config.t/0","doc":"","ref":"Beacon.LiveAdmin.Config.html#t:t/0"},{"type":"module","title":"Beacon.LiveAdmin.VisualEditor.Utils","doc":"","ref":"Beacon.LiveAdmin.VisualEditor.Utils.html"},{"type":"task","title":"mix beacon_live_admin.install","doc":"Installs Beacon LiveAdmin in a Phoenix LiveView app.","ref":"Mix.Tasks.BeaconLiveAdmin.Install.html"},{"type":"task","title":"Examples - mix beacon_live_admin.install","doc":"```bash\nmix beacon_live_admin.install\n```\n\n```bash\nmix beacon_live_admin.install --path /cms/admin\n```","ref":"Mix.Tasks.BeaconLiveAdmin.Install.html#module-examples"},{"type":"task","title":"Options - mix beacon_live_admin.install","doc":"* `--path` (optional, defaults to \"/admin\") - Where admin will be mounted. Follows the same convention as Phoenix route prefixes.","ref":"Mix.Tasks.BeaconLiveAdmin.Install.html#module-options"},{"type":"module","title":"Beacon.LiveAdmin.Cluster","doc":"Cluster management. Discover all sites running in the cluster and executes functions globally.","ref":"Beacon.LiveAdmin.Cluster.html"},{"type":"function","title":"Beacon.LiveAdmin.Cluster.call/4","doc":"Calls a function for a running `site` in the cluster.\n\nIt will call the function in only one of the available nodes to avoid double execution of `fun`.","ref":"Beacon.LiveAdmin.Cluster.html#call/4"},{"type":"function","title":"Examples - Beacon.LiveAdmin.Cluster.call/4","doc":"iex> Beacon.LiveAdmin.Cluster.call(:my_site, Beacon, :boot, [:my_site])\n    :ok","ref":"Beacon.LiveAdmin.Cluster.html#call/4-examples"},{"type":"function","title":"Beacon.LiveAdmin.Cluster.running_sites/0","doc":"Returns a list of sites running in all connected nodes in the cluster.\n\nIt doesn't try to refresh the list of running sites,\nit only returns the results cached when calling `discover_sites/0`.","ref":"Beacon.LiveAdmin.Cluster.html#running_sites/0"},{"type":"module","title":"Beacon.LiveAdmin.Plug","doc":"Required plug to load Admin pages allow navigation.\n\nMust be added in the pipeline, see the [Installation guide](file:///Users/apb/dev/beacon_live_admin/doc/installation.html#mount-admin-in-the-router) for more details.","ref":"Beacon.LiveAdmin.Plug.html"},{"type":"module","title":"Beacon.LiveAdmin.Router","doc":"Routing for Beacon LiveAdmin.","ref":"Beacon.LiveAdmin.Router.html"},{"type":"macro","title":"Beacon.LiveAdmin.Router.beacon_live_admin/2","doc":"Mount Beacon LiveAdmin routes to manage running sites in the cluster.","ref":"Beacon.LiveAdmin.Router.html#beacon_live_admin/2"},{"type":"macro","title":"Examples - Beacon.LiveAdmin.Router.beacon_live_admin/2","doc":"defmodule MyAppWeb.Router do\n      use Phoenix.Router\n      use Beacon.LiveAdmin.Router\n\n      scope \"/\", MyAppWeb do\n        pipe_through :browser\n        beacon_live_admin \"/admin\", on_mount: [SomeHook]\n      end\n    end\n\nOr using AshAuthentication to protect the admin pages:\n\n    beacon_live_admin \"/admin\", AshAuthentication.Phoenix.LiveSession.opts(on_mount: [{MyAppWeb.LiveUserAuth, :live_user_required}])","ref":"Beacon.LiveAdmin.Router.html#beacon_live_admin/2-examples"},{"type":"macro","title":"Options - Beacon.LiveAdmin.Router.beacon_live_admin/2","doc":"* `:name` (required) `atom()` - register your instance with a unique name.\n    Note that the name has to match the one used in your instance configuration.\n  * `:on_mount` (optional) - an optional list of `on_mount` hooks passed to `live_session`.\n    This will allow for authenticated routes, among other uses.\n  * `:session` (optional) - an optional extra session map or MFA tuple to be merged with the Beacon.LiveAdmin session.\n    Useful to authenticate the session using 3rd-party libs like AshAuthentication.","ref":"Beacon.LiveAdmin.Router.html#beacon_live_admin/2-options"},{"type":"function","title":"Beacon.LiveAdmin.Router.beacon_live_admin_path/1","doc":"Generates the root path with the admin prefix.","ref":"Beacon.LiveAdmin.Router.html#beacon_live_admin_path/1"},{"type":"function","title":"Example - Beacon.LiveAdmin.Router.beacon_live_admin_path/1","doc":"iex> Beacon.LiveAdmin.Router.beacon_live_admin_path(@socket)\n    \"/my_admin\"","ref":"Beacon.LiveAdmin.Router.html#beacon_live_admin_path/1-example"},{"type":"function","title":"Beacon.LiveAdmin.Router.beacon_live_admin_path/4","doc":"Generates a `path` with the proper admin prefix for a `site`.","ref":"Beacon.LiveAdmin.Router.html#beacon_live_admin_path/4"},{"type":"function","title":"Examples - Beacon.LiveAdmin.Router.beacon_live_admin_path/4","doc":"iex> Beacon.LiveAdmin.Router.beacon_live_admin_path(@socket, :my_site, \"/pages\")\n    \"/my_admin/my_site/pages\"\n\n    iex> Beacon.LiveAdmin.Router.beacon_live_admin_path(@socket, :my_site, \"/pages\", status: :draft)\n    \"/my_admin/my_site/pages?status=draft\"","ref":"Beacon.LiveAdmin.Router.html#beacon_live_admin_path/4-examples"},{"type":"function","title":"Beacon.LiveAdmin.Router.beacon_live_admin_static_path/1","doc":"Generate the path to serve files in `priv/static`.\n\nSee the actual configuration in `Beacon.LiveAdmin.Plug`.","ref":"Beacon.LiveAdmin.Router.html#beacon_live_admin_static_path/1"},{"type":"function","title":"Example - Beacon.LiveAdmin.Router.beacon_live_admin_static_path/1","doc":"iex> Beacon.LiveAdmin.Router.beacon_live_admin_static_path(\"/images/logo.webp\")\n    \"__beacon_live_admin_static__/images/logo.webp\"","ref":"Beacon.LiveAdmin.Router.html#beacon_live_admin_static_path/1-example"},{"type":"type","title":"Beacon.LiveAdmin.Router.conn_or_socket/0","doc":"","ref":"Beacon.LiveAdmin.Router.html#t:conn_or_socket/0"},{"type":"module","title":"Beacon.LiveAdmin.AdminComponents","doc":"Provides Admin UI components.\n\nThis file contains new components and also overrided Core components.","ref":"Beacon.LiveAdmin.AdminComponents.html"},{"type":"function","title":"Beacon.LiveAdmin.AdminComponents.back/1","doc":"Renders a back navigation link.","ref":"Beacon.LiveAdmin.AdminComponents.html#back/1"},{"type":"function","title":"Examples - Beacon.LiveAdmin.AdminComponents.back/1","doc":"<.back navigate={~p\"/posts\"}>Back to posts</.back>","ref":"Beacon.LiveAdmin.AdminComponents.html#back/1-examples"},{"type":"function","title":"Attributes - Beacon.LiveAdmin.AdminComponents.back/1","doc":"* `navigate` (`:any`) (required)","ref":"Beacon.LiveAdmin.AdminComponents.html#back/1-attributes"},{"type":"function","title":"Slots - Beacon.LiveAdmin.AdminComponents.back/1","doc":"* `inner_block` (required)","ref":"Beacon.LiveAdmin.AdminComponents.html#back/1-slots"},{"type":"function","title":"Beacon.LiveAdmin.AdminComponents.flash/1","doc":"Renders flash notices.","ref":"Beacon.LiveAdmin.AdminComponents.html#flash/1"},{"type":"function","title":"Examples - Beacon.LiveAdmin.AdminComponents.flash/1","doc":"<.flash kind={:info} flash={@flash} />\n    <.flash kind={:info} phx-mounted={show(\"#flash\")}>Welcome Back!</.flash>","ref":"Beacon.LiveAdmin.AdminComponents.html#flash/1-examples"},{"type":"function","title":"Attributes - Beacon.LiveAdmin.AdminComponents.flash/1","doc":"* `id` (`:string`) - the optional id of flash container. Defaults to `\"flash\"`.\n* `flash` (`:map`) - the map of flash messages to display. Defaults to `%{}`.\n* `title` (`:string`) - Defaults to `nil`.\n* `kind` (`:atom`) - used for styling and flash lookup.Must be one of `:info`, or `:error`.\n* Global attributes are accepted. the arbitrary HTML attributes to add to the flash container.","ref":"Beacon.LiveAdmin.AdminComponents.html#flash/1-attributes"},{"type":"function","title":"Slots - Beacon.LiveAdmin.AdminComponents.flash/1","doc":"* `inner_block` - the optional inner block that renders the flash message.","ref":"Beacon.LiveAdmin.AdminComponents.html#flash/1-slots"},{"type":"function","title":"Beacon.LiveAdmin.AdminComponents.flash_group/1","doc":"","ref":"Beacon.LiveAdmin.AdminComponents.html#flash_group/1"},{"type":"function","title":"Beacon.LiveAdmin.AdminComponents.header/1","doc":"","ref":"Beacon.LiveAdmin.AdminComponents.html#header/1"},{"type":"function","title":"Beacon.LiveAdmin.AdminComponents.hide/1","doc":"","ref":"Beacon.LiveAdmin.AdminComponents.html#hide/1"},{"type":"function","title":"Beacon.LiveAdmin.AdminComponents.hide/2","doc":"","ref":"Beacon.LiveAdmin.AdminComponents.html#hide/2"},{"type":"function","title":"Beacon.LiveAdmin.AdminComponents.hide_modal/1","doc":"","ref":"Beacon.LiveAdmin.AdminComponents.html#hide_modal/1"},{"type":"function","title":"Beacon.LiveAdmin.AdminComponents.list/1","doc":"Renders a data list.","ref":"Beacon.LiveAdmin.AdminComponents.html#list/1"},{"type":"function","title":"Examples - Beacon.LiveAdmin.AdminComponents.list/1","doc":"<.list>\n      <:item title=\"Title\"><%= @post.title %></:item>\n      <:item title=\"Views\"><%= @post.views %></:item>\n    </.list>","ref":"Beacon.LiveAdmin.AdminComponents.html#list/1-examples"},{"type":"function","title":"Slots - Beacon.LiveAdmin.AdminComponents.list/1","doc":"* `item` (required) - Accepts attributes:\n\n  * `title` (`:string`) (required)","ref":"Beacon.LiveAdmin.AdminComponents.html#list/1-slots"},{"type":"function","title":"Beacon.LiveAdmin.AdminComponents.main_content/1","doc":"Renders a rounded white panel that is pinned to the bottom of the screen and scrolls.","ref":"Beacon.LiveAdmin.AdminComponents.html#main_content/1"},{"type":"function","title":"Attributes - Beacon.LiveAdmin.AdminComponents.main_content/1","doc":"* `class` (`:string`) - Defaults to `\"\"`.","ref":"Beacon.LiveAdmin.AdminComponents.html#main_content/1-attributes"},{"type":"function","title":"Slots - Beacon.LiveAdmin.AdminComponents.main_content/1","doc":"* `inner_block` (required)","ref":"Beacon.LiveAdmin.AdminComponents.html#main_content/1-slots"},{"type":"function","title":"Beacon.LiveAdmin.AdminComponents.show/1","doc":"","ref":"Beacon.LiveAdmin.AdminComponents.html#show/1"},{"type":"function","title":"Beacon.LiveAdmin.AdminComponents.show/2","doc":"","ref":"Beacon.LiveAdmin.AdminComponents.html#show/2"},{"type":"function","title":"Beacon.LiveAdmin.AdminComponents.simple_form/1","doc":"Renders a simple form.","ref":"Beacon.LiveAdmin.AdminComponents.html#simple_form/1"},{"type":"function","title":"Examples - Beacon.LiveAdmin.AdminComponents.simple_form/1","doc":"<.simple_form for={@form} phx-change=\"validate\" phx-submit=\"save\">\n      <.input field={@form[:email]} label=\"Email\"/>\n      <.input field={@form[:username]} label=\"Username\" />\n      <:actions>\n        <.button>Save</.button>\n      </:actions>\n    </.simple_form>","ref":"Beacon.LiveAdmin.AdminComponents.html#simple_form/1-examples"},{"type":"function","title":"Attributes - Beacon.LiveAdmin.AdminComponents.simple_form/1","doc":"* `for` (`:any`) (required) - the datastructure for the form.\n* `as` (`:any`) - the server side parameter to collect all input under. Defaults to `nil`.\n* Global attributes are accepted. the arbitrary HTML attributes to apply to the form tag. Supports all globals plus: `[\"autocomplete\", \"name\", \"rel\", \"action\", \"enctype\", \"method\", \"novalidate\", \"target\"]`.","ref":"Beacon.LiveAdmin.AdminComponents.html#simple_form/1-attributes"},{"type":"function","title":"Slots - Beacon.LiveAdmin.AdminComponents.simple_form/1","doc":"* `inner_block` (required)\n* `actions` - the slot for form actions, such as a submit button.","ref":"Beacon.LiveAdmin.AdminComponents.html#simple_form/1-slots"},{"type":"function","title":"Beacon.LiveAdmin.AdminComponents.site_selector/1","doc":"Renders a select input with the available sites to select.","ref":"Beacon.LiveAdmin.AdminComponents.html#site_selector/1"},{"type":"function","title":"Examples - Beacon.LiveAdmin.AdminComponents.site_selector/1","doc":"<.site_selector selected_site=\"dev\" options={[:dev, :dy]} />","ref":"Beacon.LiveAdmin.AdminComponents.html#site_selector/1-examples"},{"type":"function","title":"Attributes - Beacon.LiveAdmin.AdminComponents.site_selector/1","doc":"* `selected_site` (`:string`) - Defaults to `\"\"`.\n* `options` (`:list`) - Defaults to `[]`.","ref":"Beacon.LiveAdmin.AdminComponents.html#site_selector/1-attributes"},{"type":"function","title":"Beacon.LiveAdmin.AdminComponents.table/1","doc":"Renders a table with generic styling.","ref":"Beacon.LiveAdmin.AdminComponents.html#table/1"},{"type":"function","title":"Examples - Beacon.LiveAdmin.AdminComponents.table/1","doc":"<.table id=\"users\" rows={@users}>\n      <:col :let={user} label=\"id\"><%= user.id %></:col>\n      <:col :let={user} label=\"username\"><%= user.username %></:col>\n    </.table>","ref":"Beacon.LiveAdmin.AdminComponents.html#table/1-examples"},{"type":"function","title":"Attributes - Beacon.LiveAdmin.AdminComponents.table/1","doc":"* `id` (`:string`) (required)\n* `rows` (`:list`) (required)\n* `row_id` (`:any`) - the function for generating the row id. Defaults to `nil`.\n* `row_click` (`:any`) - the function for handling phx-click on each row. Defaults to `nil`.\n* `row_item` (`:any`) - the function for mapping each row before calling the :col and :action slots. Defaults to `&Function.identity/1`.","ref":"Beacon.LiveAdmin.AdminComponents.html#table/1-attributes"},{"type":"function","title":"Slots - Beacon.LiveAdmin.AdminComponents.table/1","doc":"* `col` (required) - Accepts attributes:\n\n  * `label` (`:string`)\n* `action` - the slot for showing user actions in the last table column.","ref":"Beacon.LiveAdmin.AdminComponents.html#table/1-slots"},{"type":"function","title":"Beacon.LiveAdmin.AdminComponents.table_pagination/1","doc":"Renders pagination to nagivate table results.","ref":"Beacon.LiveAdmin.AdminComponents.html#table_pagination/1"},{"type":"function","title":"Attributes - Beacon.LiveAdmin.AdminComponents.table_pagination/1","doc":"* `socket` (`Phoenix.LiveView.Socket`) (required)\n* `page` (`Beacon.LiveAdmin.PageBuilder.Page`) (required)\n* `limit` (`:integer`) - Defaults to `11`.","ref":"Beacon.LiveAdmin.AdminComponents.html#table_pagination/1-attributes"},{"type":"function","title":"Beacon.LiveAdmin.AdminComponents.table_search/1","doc":"Renders a search input text to filter table results.","ref":"Beacon.LiveAdmin.AdminComponents.html#table_search/1"},{"type":"function","title":"Attributes - Beacon.LiveAdmin.AdminComponents.table_search/1","doc":"* `table` (`Beacon.LiveAdmin.PageBuilder.Table`) (required)\n* `placeholder` (`:string`)","ref":"Beacon.LiveAdmin.AdminComponents.html#table_search/1-attributes"},{"type":"function","title":"Beacon.LiveAdmin.AdminComponents.table_sort/1","doc":"Renders a select input to sort table results.","ref":"Beacon.LiveAdmin.AdminComponents.html#table_sort/1"},{"type":"function","title":"Attributes - Beacon.LiveAdmin.AdminComponents.table_sort/1","doc":"* `table` (`Beacon.LiveAdmin.PageBuilder.Table`) (required)\n* `options` (`:list`) (required)","ref":"Beacon.LiveAdmin.AdminComponents.html#table_sort/1-attributes"},{"type":"function","title":"Beacon.LiveAdmin.AdminComponents.thumbnail/1","doc":"Renders a thumbnail image.","ref":"Beacon.LiveAdmin.AdminComponents.html#thumbnail/1"},{"type":"function","title":"Attributes - Beacon.LiveAdmin.AdminComponents.thumbnail/1","doc":"* `source` (`:string`) - Defaults to `nil`.","ref":"Beacon.LiveAdmin.AdminComponents.html#thumbnail/1-attributes"},{"type":"function","title":"Beacon.LiveAdmin.AdminComponents.translate_errors/2","doc":"","ref":"Beacon.LiveAdmin.AdminComponents.html#translate_errors/2"},{"type":"module","title":"Beacon.LiveAdmin.CoreComponents","doc":"Core Components","ref":"Beacon.LiveAdmin.CoreComponents.html"},{"type":"function","title":"Beacon.LiveAdmin.CoreComponents.back/1","doc":"Renders a back navigation link.","ref":"Beacon.LiveAdmin.CoreComponents.html#back/1"},{"type":"function","title":"Examples - Beacon.LiveAdmin.CoreComponents.back/1","doc":"<.back navigate={~p\"/posts\"}>Back to posts</.back>","ref":"Beacon.LiveAdmin.CoreComponents.html#back/1-examples"},{"type":"function","title":"Attributes - Beacon.LiveAdmin.CoreComponents.back/1","doc":"* `navigate` (`:any`) (required)","ref":"Beacon.LiveAdmin.CoreComponents.html#back/1-attributes"},{"type":"function","title":"Slots - Beacon.LiveAdmin.CoreComponents.back/1","doc":"* `inner_block` (required)","ref":"Beacon.LiveAdmin.CoreComponents.html#back/1-slots"},{"type":"function","title":"Beacon.LiveAdmin.CoreComponents.button/1","doc":"Renders a button.","ref":"Beacon.LiveAdmin.CoreComponents.html#button/1"},{"type":"function","title":"Examples - Beacon.LiveAdmin.CoreComponents.button/1","doc":"<.button>Send!</.button>\n    <.button phx-click=\"go\" class=\"ml-2\">Send!</.button>","ref":"Beacon.LiveAdmin.CoreComponents.html#button/1-examples"},{"type":"function","title":"Attributes - Beacon.LiveAdmin.CoreComponents.button/1","doc":"* `type` (`:string`) - Defaults to `nil`.\n* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted. Supports all globals plus: `[\"disabled\", \"form\", \"name\", \"value\"]`.","ref":"Beacon.LiveAdmin.CoreComponents.html#button/1-attributes"},{"type":"function","title":"Slots - Beacon.LiveAdmin.CoreComponents.button/1","doc":"* `inner_block` (required)","ref":"Beacon.LiveAdmin.CoreComponents.html#button/1-slots"},{"type":"function","title":"Beacon.LiveAdmin.CoreComponents.error/1","doc":"Generates a generic error message.","ref":"Beacon.LiveAdmin.CoreComponents.html#error/1"},{"type":"function","title":"Slots - Beacon.LiveAdmin.CoreComponents.error/1","doc":"* `inner_block` (required)","ref":"Beacon.LiveAdmin.CoreComponents.html#error/1-slots"},{"type":"function","title":"Beacon.LiveAdmin.CoreComponents.flash/1","doc":"Renders flash notices.","ref":"Beacon.LiveAdmin.CoreComponents.html#flash/1"},{"type":"function","title":"Examples - Beacon.LiveAdmin.CoreComponents.flash/1","doc":"<.flash kind={:info} flash={@flash} />\n    <.flash kind={:info} phx-mounted={show(\"#flash\")}>Welcome Back!</.flash>","ref":"Beacon.LiveAdmin.CoreComponents.html#flash/1-examples"},{"type":"function","title":"Attributes - Beacon.LiveAdmin.CoreComponents.flash/1","doc":"* `id` (`:string`) - the optional id of flash container. Defaults to `\"flash\"`.\n* `flash` (`:map`) - the map of flash messages to display. Defaults to `%{}`.\n* `title` (`:string`) - Defaults to `nil`.\n* `kind` (`:atom`) - used for styling and flash lookup.Must be one of `:info`, or `:error`.\n* Global attributes are accepted. the arbitrary HTML attributes to add to the flash container.","ref":"Beacon.LiveAdmin.CoreComponents.html#flash/1-attributes"},{"type":"function","title":"Slots - Beacon.LiveAdmin.CoreComponents.flash/1","doc":"* `inner_block` - the optional inner block that renders the flash message.","ref":"Beacon.LiveAdmin.CoreComponents.html#flash/1-slots"},{"type":"function","title":"Beacon.LiveAdmin.CoreComponents.flash_group/1","doc":"Shows the flash group with standard titles and content.","ref":"Beacon.LiveAdmin.CoreComponents.html#flash_group/1"},{"type":"function","title":"Examples - Beacon.LiveAdmin.CoreComponents.flash_group/1","doc":"<.flash_group flash={@flash} />","ref":"Beacon.LiveAdmin.CoreComponents.html#flash_group/1-examples"},{"type":"function","title":"Attributes - Beacon.LiveAdmin.CoreComponents.flash_group/1","doc":"* `flash` (`:map`) (required) - the map of flash messages.","ref":"Beacon.LiveAdmin.CoreComponents.html#flash_group/1-attributes"},{"type":"function","title":"Beacon.LiveAdmin.CoreComponents.header/1","doc":"Renders a header with title.","ref":"Beacon.LiveAdmin.CoreComponents.html#header/1"},{"type":"function","title":"Attributes - Beacon.LiveAdmin.CoreComponents.header/1","doc":"* `class` (`:string`) - Defaults to `nil`.","ref":"Beacon.LiveAdmin.CoreComponents.html#header/1-attributes"},{"type":"function","title":"Slots - Beacon.LiveAdmin.CoreComponents.header/1","doc":"* `inner_block` (required)\n* `subtitle`\n* `actions`","ref":"Beacon.LiveAdmin.CoreComponents.html#header/1-slots"},{"type":"function","title":"Beacon.LiveAdmin.CoreComponents.hide/2","doc":"","ref":"Beacon.LiveAdmin.CoreComponents.html#hide/2"},{"type":"function","title":"Beacon.LiveAdmin.CoreComponents.hide_modal/2","doc":"","ref":"Beacon.LiveAdmin.CoreComponents.html#hide_modal/2"},{"type":"function","title":"Beacon.LiveAdmin.CoreComponents.icon/1","doc":"Renders a [Hero Icon](https://heroicons.com).\n\nHero icons come in three styles – outline, solid, and mini.\nBy default, the outline style is used, but solid an mini may\nbe applied by using the `-solid` and `-mini` suffix.\n\nYou can customize the size and colors of the icons by setting\nwidth, height, and background color classes.\n\nIcons are extracted from your `assets/vendor/heroicons` directory and bundled\nwithin your compiled app.css by the plugin in your `assets/tailwind.config.js`.","ref":"Beacon.LiveAdmin.CoreComponents.html#icon/1"},{"type":"function","title":"Examples - Beacon.LiveAdmin.CoreComponents.icon/1","doc":"<.icon name=\"hero-x-mark-solid\" />\n    <.icon name=\"hero-arrow-path\" class=\"w-3 h-3 ml-1 animate-spin\" />","ref":"Beacon.LiveAdmin.CoreComponents.html#icon/1-examples"},{"type":"function","title":"Attributes - Beacon.LiveAdmin.CoreComponents.icon/1","doc":"* `name` (`:string`) (required)\n* `class` (`:string`) - Defaults to `nil`.","ref":"Beacon.LiveAdmin.CoreComponents.html#icon/1-attributes"},{"type":"function","title":"Beacon.LiveAdmin.CoreComponents.input/1","doc":"Renders an input with label and error messages.\n\nA `%Phoenix.HTML.Form{}` and field name may be passed to the input\nto build input names and error messages, or all the attributes and\nerrors may be passed explicitly.","ref":"Beacon.LiveAdmin.CoreComponents.html#input/1"},{"type":"function","title":"Examples - Beacon.LiveAdmin.CoreComponents.input/1","doc":"<.input field={@form[:email]} type=\"email\" />\n    <.input name=\"my-input\" errors={[\"oh no!\"]} />","ref":"Beacon.LiveAdmin.CoreComponents.html#input/1-examples"},{"type":"function","title":"Attributes - Beacon.LiveAdmin.CoreComponents.input/1","doc":"* `id` (`:any`) - Defaults to `nil`.\n* `name` (`:any`)\n* `label` (`:string`) - Defaults to `nil`.\n* `value` (`:any`)\n* `type` (`:string`) - Defaults to `\"text\"`.\n* `field` (`Phoenix.HTML.FormField`) - a form field struct retrieved from the form, for example: @form[:email].\n* `errors` (`:list`) - Defaults to `[]`.\n* `checked` (`:boolean`) - the checked flag for checkbox inputs.\n* `prompt` (`:string`) - the prompt for select inputs. Defaults to `nil`.\n* `options` (`:list`) - the options to pass to Phoenix.HTML.Form.options_for_select/2.\n* `multiple` (`:boolean`) - the multiple flag for select inputs. Defaults to `false`.\n* Global attributes are accepted. Supports all globals plus: `[\"autocomplete\", \"cols\", \"disabled\", \"form\", \"list\", \"max\", \"maxlength\", \"min\", \"minlength\", \"pattern\", \"placeholder\", \"readonly\", \"required\", \"rows\", \"size\", \"step\"]`.","ref":"Beacon.LiveAdmin.CoreComponents.html#input/1-attributes"},{"type":"function","title":"Slots - Beacon.LiveAdmin.CoreComponents.input/1","doc":"* `inner_block`","ref":"Beacon.LiveAdmin.CoreComponents.html#input/1-slots"},{"type":"function","title":"Beacon.LiveAdmin.CoreComponents.label/1","doc":"Renders a label.","ref":"Beacon.LiveAdmin.CoreComponents.html#label/1"},{"type":"function","title":"Attributes - Beacon.LiveAdmin.CoreComponents.label/1","doc":"* `for` (`:string`) - Defaults to `nil`.","ref":"Beacon.LiveAdmin.CoreComponents.html#label/1-attributes"},{"type":"function","title":"Slots - Beacon.LiveAdmin.CoreComponents.label/1","doc":"* `inner_block` (required)","ref":"Beacon.LiveAdmin.CoreComponents.html#label/1-slots"},{"type":"function","title":"Beacon.LiveAdmin.CoreComponents.list/1","doc":"Renders a data list.","ref":"Beacon.LiveAdmin.CoreComponents.html#list/1"},{"type":"function","title":"Examples - Beacon.LiveAdmin.CoreComponents.list/1","doc":"<.list>\n      <:item title=\"Title\"><%= @post.title %></:item>\n      <:item title=\"Views\"><%= @post.views %></:item>\n    </.list>","ref":"Beacon.LiveAdmin.CoreComponents.html#list/1-examples"},{"type":"function","title":"Slots - Beacon.LiveAdmin.CoreComponents.list/1","doc":"* `item` (required) - Accepts attributes:\n\n  * `title` (`:string`) (required)","ref":"Beacon.LiveAdmin.CoreComponents.html#list/1-slots"},{"type":"function","title":"Beacon.LiveAdmin.CoreComponents.modal/1","doc":"Renders a modal.","ref":"Beacon.LiveAdmin.CoreComponents.html#modal/1"},{"type":"function","title":"Examples - Beacon.LiveAdmin.CoreComponents.modal/1","doc":"<.modal id=\"confirm-modal\">\n      This is a modal.\n    </.modal>\n\nJS commands may be passed to the `:on_cancel` to configure\nthe closing/cancel event, for example:\n\n    <.modal id=\"confirm\" on_cancel={JS.navigate(~p\"/posts\")}>\n      This is another modal.\n    </.modal>","ref":"Beacon.LiveAdmin.CoreComponents.html#modal/1-examples"},{"type":"function","title":"Attributes - Beacon.LiveAdmin.CoreComponents.modal/1","doc":"* `id` (`:string`) (required)\n* `show` (`:boolean`) - Defaults to `false`.\n* `on_cancel` (`Phoenix.LiveView.JS`) - Defaults to `%Phoenix.LiveView.JS{ops: []}`.","ref":"Beacon.LiveAdmin.CoreComponents.html#modal/1-attributes"},{"type":"function","title":"Slots - Beacon.LiveAdmin.CoreComponents.modal/1","doc":"* `inner_block` (required)","ref":"Beacon.LiveAdmin.CoreComponents.html#modal/1-slots"},{"type":"function","title":"Beacon.LiveAdmin.CoreComponents.show/2","doc":"","ref":"Beacon.LiveAdmin.CoreComponents.html#show/2"},{"type":"function","title":"Beacon.LiveAdmin.CoreComponents.show_modal/2","doc":"","ref":"Beacon.LiveAdmin.CoreComponents.html#show_modal/2"},{"type":"function","title":"Beacon.LiveAdmin.CoreComponents.simple_form/1","doc":"Renders a simple form.","ref":"Beacon.LiveAdmin.CoreComponents.html#simple_form/1"},{"type":"function","title":"Examples - Beacon.LiveAdmin.CoreComponents.simple_form/1","doc":"<.simple_form for={@form} phx-change=\"validate\" phx-submit=\"save\">\n      <.input field={@form[:email]} label=\"Email\"/>\n      <.input field={@form[:username]} label=\"Username\" />\n      <:actions>\n        <.button>Save</.button>\n      </:actions>\n    </.simple_form>","ref":"Beacon.LiveAdmin.CoreComponents.html#simple_form/1-examples"},{"type":"function","title":"Attributes - Beacon.LiveAdmin.CoreComponents.simple_form/1","doc":"* `for` (`:any`) (required) - the datastructure for the form.\n* `as` (`:any`) - the server side parameter to collect all input under. Defaults to `nil`.\n* Global attributes are accepted. the arbitrary HTML attributes to apply to the form tag. Supports all globals plus: `[\"autocomplete\", \"name\", \"rel\", \"action\", \"enctype\", \"method\", \"novalidate\", \"target\"]`.","ref":"Beacon.LiveAdmin.CoreComponents.html#simple_form/1-attributes"},{"type":"function","title":"Slots - Beacon.LiveAdmin.CoreComponents.simple_form/1","doc":"* `inner_block` (required)\n* `actions` - the slot for form actions, such as a submit button.","ref":"Beacon.LiveAdmin.CoreComponents.html#simple_form/1-slots"},{"type":"function","title":"Beacon.LiveAdmin.CoreComponents.table/1","doc":"Renders a table with generic styling.","ref":"Beacon.LiveAdmin.CoreComponents.html#table/1"},{"type":"function","title":"Examples - Beacon.LiveAdmin.CoreComponents.table/1","doc":"<.table id=\"users\" rows={@users}>\n      <:col :let={user} label=\"id\"><%= user.id %></:col>\n      <:col :let={user} label=\"username\"><%= user.username %></:col>\n    </.table>","ref":"Beacon.LiveAdmin.CoreComponents.html#table/1-examples"},{"type":"function","title":"Attributes - Beacon.LiveAdmin.CoreComponents.table/1","doc":"* `id` (`:string`) (required)\n* `rows` (`:list`) (required)\n* `row_id` (`:any`) - the function for generating the row id. Defaults to `nil`.\n* `row_click` (`:any`) - the function for handling phx-click on each row. Defaults to `nil`.\n* `row_item` (`:any`) - the function for mapping each row before calling the :col and :action slots. Defaults to `&Function.identity/1`.","ref":"Beacon.LiveAdmin.CoreComponents.html#table/1-attributes"},{"type":"function","title":"Slots - Beacon.LiveAdmin.CoreComponents.table/1","doc":"* `col` (required) - Accepts attributes:\n\n  * `label` (`:string`)\n* `action` - the slot for showing user actions in the last table column.","ref":"Beacon.LiveAdmin.CoreComponents.html#table/1-slots"},{"type":"function","title":"Beacon.LiveAdmin.CoreComponents.translate_error/1","doc":"Translates an error message using gettext.","ref":"Beacon.LiveAdmin.CoreComponents.html#translate_error/1"},{"type":"function","title":"Beacon.LiveAdmin.CoreComponents.translate_errors/2","doc":"Translates the errors for a field from a keyword list of errors.","ref":"Beacon.LiveAdmin.CoreComponents.html#translate_errors/2"},{"type":"behaviour","title":"Beacon.LiveAdmin.PageBuilder","doc":"The foundation for building admin pages.\n\nEither built-in pages and custom pages on your app should implement these callbacks\nto properly mount the menu and the private assigns used by LiveAdmin.","ref":"Beacon.LiveAdmin.PageBuilder.html"},{"type":"callback","title":"Beacon.LiveAdmin.PageBuilder.handle_event/3","doc":"","ref":"Beacon.LiveAdmin.PageBuilder.html#c:handle_event/3"},{"type":"callback","title":"Beacon.LiveAdmin.PageBuilder.handle_info/2","doc":"","ref":"Beacon.LiveAdmin.PageBuilder.html#c:handle_info/2"},{"type":"callback","title":"Beacon.LiveAdmin.PageBuilder.handle_params/3","doc":"","ref":"Beacon.LiveAdmin.PageBuilder.html#c:handle_params/3"},{"type":"callback","title":"Beacon.LiveAdmin.PageBuilder.init/1","doc":"","ref":"Beacon.LiveAdmin.PageBuilder.html#c:init/1"},{"type":"callback","title":"Beacon.LiveAdmin.PageBuilder.menu_link/2","doc":"","ref":"Beacon.LiveAdmin.PageBuilder.html#c:menu_link/2"},{"type":"callback","title":"Beacon.LiveAdmin.PageBuilder.menu_link/3","doc":"","ref":"Beacon.LiveAdmin.PageBuilder.html#c:menu_link/3"},{"type":"callback","title":"Beacon.LiveAdmin.PageBuilder.mount/3","doc":"","ref":"Beacon.LiveAdmin.PageBuilder.html#c:mount/3"},{"type":"callback","title":"Beacon.LiveAdmin.PageBuilder.render/1","doc":"","ref":"Beacon.LiveAdmin.PageBuilder.html#c:render/1"},{"type":"type","title":"Beacon.LiveAdmin.PageBuilder.session/0","doc":"","ref":"Beacon.LiveAdmin.PageBuilder.html#t:session/0"},{"type":"type","title":"Beacon.LiveAdmin.PageBuilder.unsigned_params/0","doc":"","ref":"Beacon.LiveAdmin.PageBuilder.html#t:unsigned_params/0"},{"type":"module","title":"Beacon.LiveAdmin.PageBuilder.Page","doc":"Represents a Page in the LiveAdmin UI.","ref":"Beacon.LiveAdmin.PageBuilder.Page.html"},{"type":"type","title":"Beacon.LiveAdmin.PageBuilder.Page.t/0","doc":"","ref":"Beacon.LiveAdmin.PageBuilder.Page.html#t:t/0"},{"type":"module","title":"Beacon.LiveAdmin.PageBuilder.Table","doc":"Represents a Table in the LiveAdmin UI, with pagination, filtering, and sorting.","ref":"Beacon.LiveAdmin.PageBuilder.Table.html"},{"type":"function","title":"Beacon.LiveAdmin.PageBuilder.Table.build/1","doc":"Initializes a new `Table` struct.","ref":"Beacon.LiveAdmin.PageBuilder.Table.html#build/1"},{"type":"function","title":"Options - Beacon.LiveAdmin.PageBuilder.Table.build/1","doc":"* `sort_by` - (required) the field on which to sort the table contents\n  * `per_page` - the number of items to display per page (defaults to 15)","ref":"Beacon.LiveAdmin.PageBuilder.Table.html#build/1-options"},{"type":"function","title":"Beacon.LiveAdmin.PageBuilder.Table.goto_path/3","doc":"Generates a path to navigate from the current page to another given page.\n\nIf the current and goto pages are the same, it will still append table params to the path.","ref":"Beacon.LiveAdmin.PageBuilder.Table.html#goto_path/3"},{"type":"function","title":"Usage - Beacon.LiveAdmin.PageBuilder.Table.goto_path/3","doc":"```\n<.link patch={Table.goto_path(@socket, @page)}>\n```","ref":"Beacon.LiveAdmin.PageBuilder.Table.html#goto_path/3-usage"},{"type":"function","title":"Beacon.LiveAdmin.PageBuilder.Table.handle_params/3","doc":"Updates the current page based on incoming params and a `count_fn` which returns the number of\nitems which have already been seen.\n\nCan be called as a helper inside a `c:Beacon.LiveAdmin.PageBuilder.handle_params/3` callback when\nupdating params for a Table.","ref":"Beacon.LiveAdmin.PageBuilder.Table.html#handle_params/3"},{"type":"function","title":"Beacon.LiveAdmin.PageBuilder.Table.next_path/2","doc":"Generates a path for the next page of a paginated table.","ref":"Beacon.LiveAdmin.PageBuilder.Table.html#next_path/2"},{"type":"function","title":"Usage - Beacon.LiveAdmin.PageBuilder.Table.next_path/2","doc":"```\n<.link patch={Table.next_path(@socket, @page)}>\n```","ref":"Beacon.LiveAdmin.PageBuilder.Table.html#next_path/2-usage"},{"type":"function","title":"Beacon.LiveAdmin.PageBuilder.Table.prev_path/2","doc":"Generates a path for the previous page of a paginated table.","ref":"Beacon.LiveAdmin.PageBuilder.Table.html#prev_path/2"},{"type":"function","title":"Usage - Beacon.LiveAdmin.PageBuilder.Table.prev_path/2","doc":"```\n<.link patch={Table.prev_path(@socket, @page)}>\n```","ref":"Beacon.LiveAdmin.PageBuilder.Table.html#prev_path/2-usage"},{"type":"function","title":"Beacon.LiveAdmin.PageBuilder.Table.query_params/2","doc":"Creates a list of query params based on the existing params in a given `table` and a new set of incoming params.\n\nThe existing and incoming params will be merged, with precedence for the latter (incoming will overwrite existing).","ref":"Beacon.LiveAdmin.PageBuilder.Table.html#query_params/2"},{"type":"type","title":"Beacon.LiveAdmin.PageBuilder.Table.t/0","doc":"","ref":"Beacon.LiveAdmin.PageBuilder.Table.html#t:t/0"},{"type":"function","title":"Beacon.LiveAdmin.PageBuilder.Table.update/2","doc":"Pushes updated Table data to the websocket.\n\nThe Beacon Page containing the table will be automatically updated","ref":"Beacon.LiveAdmin.PageBuilder.Table.html#update/2"},{"type":"exception","title":"Beacon.LiveAdmin.ClusterError","doc":"Raised when there is an error in calling a remove Beacon function through the cluster.\n\nIf you're seeing this error, make sure the node running the site is connected to the cluster.","ref":"Beacon.LiveAdmin.ClusterError.html"},{"type":"exception","title":"Beacon.LiveAdmin.ConfigError","doc":"Raised when some option in `Beacon.LiveAdmin.Config` is invalid.\n\nIf you are seeing this error, check `application.ex` where your admin instance config is defined.\nDescription and examples of each allowed configuration option can be found in `Beacon.LiveAdmin.Config.new/1`","ref":"Beacon.LiveAdmin.ConfigError.html"},{"type":"extras","title":"Changelog","doc":"# Changelog","ref":"changelog.html"},{"type":"extras","title":"0.4.3 (2025-03-31) - Changelog","doc":"","ref":"changelog.html#0-4-3-2025-03-31"},{"type":"extras","title":"Fixes - Changelog","doc":"- [Components] Remove gap in components attributes editor\n  - [Event Handlers] Fix event_params in \"variables available\" message\n  - [Deps] Relax `:tailwind` version","ref":"changelog.html#fixes"},{"type":"extras","title":"Changes - Changelog","doc":"- [Deps] Vendor heroicons using the npm package","ref":"changelog.html#changes"},{"type":"extras","title":"0.4.2 (2025-03-24) - Changelog","doc":"","ref":"changelog.html#0-4-2-2025-03-24"},{"type":"extras","title":"Enhancements - Changelog","doc":"- [Visual Editor] Added Border controls\n  - [Visual Editor] Added Padding controls\n  - [Visual Editor] Added Margin controls\n  - [Visual Editor] Added Layout controls\n  - [Visual Editor] Added Typography controls\n  - [Deps] Bump Svelte to v5\n  - [Deps] Update heroicons","ref":"changelog.html#enhancements"},{"type":"extras","title":"Fixes - Changelog","doc":"- [Media Library] Fix search when form is submitted","ref":"changelog.html#fixes"},{"type":"extras","title":"0.4.1 (2025-02-20) - Changelog","doc":"","ref":"changelog.html#0-4-1-2025-02-20"},{"type":"extras","title":"Enhancements - Changelog","doc":"- Added `:session` option to `beacon_live_admin/2`","ref":"changelog.html#enhancements"},{"type":"extras","title":"Fixes - Changelog","doc":"- Properly forwards and execute `on_mount` hooks on pages\n  - Remove StationUI components from docs\n  - Remove VisualEditor components from docs\n  - Compiler warning for unreachable `cond` clause in dev env","ref":"changelog.html#fixes"},{"type":"extras","title":"0.4.0 (2025-02-12) - Changelog","doc":"","ref":"changelog.html#0-4-0-2025-02-12"},{"type":"extras","title":"Enhancements - Changelog","doc":"- Adds page to define custom JS Hooks\n  - Updated UI styling with StationUI\n  - Unsaved changes will now be saved when publishing, instead of discarded\n  - Adds Unpublish button to Page editor\n  - Page editor now shows draft/published status\n  - [Visual Editor] Add Opacity property control","ref":"changelog.html#enhancements"},{"type":"extras","title":"Fixes - Changelog","doc":"- Fixed a bug where MediaLibrary could check for file contents on the wrong node in multi-node deployments\n  - Fixed a bug where using the code editor could reset other form fields on the page\n  - Saving as draft no longer resets the form for new pages\n  - Pin Tailwind v3 to avoid errors with the unsupported v4\n  - Properly start `:pg` in the supervision tree to avoid init errors","ref":"changelog.html#fixes"},{"type":"extras","title":"Chores - Changelog","doc":"- Remove unnecessary node check on RPC calls\n  - [Visual Editor] Migrate the sidebar from Svelte to LiveView\n  - Make `:igniter` optional","ref":"changelog.html#chores"},{"type":"extras","title":"Breaking Changes - Changelog","doc":"- Require minimum `:igniter` v0.5\n  - `beacon_live_admin.install` - removed command alias `-p`","ref":"changelog.html#breaking-changes"},{"type":"extras","title":"0.3.1 (2024-12-12) - Changelog","doc":"","ref":"changelog.html#0-3-1-2024-12-12"},{"type":"extras","title":"Fixes - Changelog","doc":"- Support LiveView 0.20\n  - Fix \"new meta tag\" modal close event being sent to wrong target","ref":"changelog.html#fixes"},{"type":"extras","title":"0.3.0 (2024-12-05) - Changelog","doc":"","ref":"changelog.html#0-3-0-2024-12-05"},{"type":"extras","title":"Enhancements - Changelog","doc":"- Support Phoenix LiveView 1.0\n  - Introduce `Beacon.LiveAdmin.Config`","ref":"changelog.html#enhancements"},{"type":"extras","title":"Fixes - Changelog","doc":"- [Visual Editor] Decode HTML entities in Tailwind compiler","ref":"changelog.html#fixes"},{"type":"extras","title":"Chores - Changelog","doc":"- Remove unused router helper `beacon_live_admin_url/4`","ref":"changelog.html#chores"},{"type":"extras","title":"0.2.0 (2024-11-14) - Changelog","doc":"","ref":"changelog.html#0-2-0-2024-11-14"},{"type":"extras","title":"Enhancements - Changelog","doc":"- Add `beacon_live_admin.install` Igniter task\n  - [Media Library] Display asset file name on show details to allow easy copy and paste","ref":"changelog.html#enhancements"},{"type":"extras","title":"Fixes - Changelog","doc":"- [Visual Editor] Pass down slot to nested components\n  - [Visual Editor] Improve flow detection","ref":"changelog.html#fixes"},{"type":"extras","title":"0.1.1 (2024-10-23) - Changelog","doc":"","ref":"changelog.html#0-1-1-2024-10-23"},{"type":"extras","title":"Fixes - Changelog","doc":"- [Visual Editor] Allow to drop elements into the page over the layout\n  - [Visual Editor] Fix small bug that prevented deleting an item","ref":"changelog.html#fixes"},{"type":"extras","title":"0.1.0 (2024-10-09) - Changelog","doc":"","ref":"changelog.html#0-1-0-2024-10-09"},{"type":"extras","title":"Enhancements - Changelog","doc":"- [Visual Editor] Keep comments in their correct position in the tree #268\n  - [Visual Editor] Allow to drag the parent of the selected element #267\n  - [Visual Editor] Improve bidirectional drag and drop #266\n  - [Visual Editor] Animate drag and drop using FLIP approach and simplify calculation of all elements #264\n  - Reorder pages - [#261](https://github.com/BeaconCMS/beacon_live_admin/pull/261)\n  - Added Shared Info Handlers (`info_handle` callbacks) page - [#210](https://github.com/BeaconCMS/beacon_live_admin/pull/210) by [@ddink](https://github.com/ddink)","ref":"changelog.html#enhancements"},{"type":"extras","title":"Fixes - Changelog","doc":"- [Page Editor] remove path whitespace in new pages form\n  - Remove unnecessary `:plug_cowboy` dependency - [#262](https://github.com/BeaconCMS/beacon_live_admin/pull/262)","ref":"changelog.html#fixes"},{"type":"extras","title":"Documentation - Changelog","doc":"- Fix install guide link","ref":"changelog.html#documentation"},{"type":"extras","title":"0.1.0-rc.2 (2024-09-21 - Changelog","doc":"","ref":"changelog.html#0-1-0-rc-2-2024-09-21"},{"type":"extras","title":"Breaking Changes - Changelog","doc":"- Require minimum Elixir v1.14\n  - Require minimum Gettext v0.26 to use the new backend module","ref":"changelog.html#breaking-changes"},{"type":"extras","title":"Fixes - Changelog","doc":"- [Visual Editor] Fix a race condition between update AST and save change events - [#240](https://github.com/BeaconCMS/beacon_live_admin/pull/240)\n  - Skip `PageBuilder.Table.handle_params/3` when the requested page has no pagination data - [#236](https://github.com/BeaconCMS/beacon_live_admin/pull/236)","ref":"changelog.html#fixes"},{"type":"extras","title":"Enhancements - Changelog","doc":"- [Visual Editor] Improve DnD highlight states and simplify logic significantly - [#219](https://github.com/BeaconCMS/beacon_live_admin/pull/219)\n  - [Visual Editor] Better detect overlapping when dragging elements to reorder - [#216](https://github.com/BeaconCMS/beacon_live_admin/pull/216)\n  - [Visual Editor] Display a delete icon on selected elements - [#209](https://github.com/BeaconCMS/beacon_live_admin/pull/209)\n  - [Visual Editor] Better detect horizontal/vertical drag and drop flow - [#215](https://github.com/BeaconCMS/beacon_live_admin/pull/215)","ref":"changelog.html#enhancements"},{"type":"extras","title":"Fixes - Changelog","doc":"- [Dev] Fix tailwind watch config\n  - [Visual Editor] Fix drag button orientation - [#218](https://github.com/BeaconCMS/beacon_live_admin/pull/218)\n  - [Visual Editor] Do not show drag buttons on elements that are only children - [#217](https://github.com/BeaconCMS/beacon_live_admin/pull/217)\n  - [Visual Editor] Keep current element select after drag and drop event - [#214](https://github.com/BeaconCMS/beacon_live_admin/pull/214)","ref":"changelog.html#fixes"},{"type":"extras","title":"0.1.0-rc.1 (2024-08-27) - Changelog","doc":"","ref":"changelog.html#0-1-0-rc-1-2024-08-27"},{"type":"extras","title":"Enhancements - Changelog","doc":"- [Event Handler] Added Event Handlers - [#195](https://github.com/BeaconCMS/beacon_live_admin/pull/195)\n  - [Visual Editor] Allow to reorder an element among its siblings with drag and drop - [#174](https://github.com/BeaconCMS/beacon_live_admin/pull/174)","ref":"changelog.html#enhancements"},{"type":"extras","title":"Fixes - Changelog","doc":"- [Visual Editor] Disable dragLeave trigger on drag placeholder - [#208](https://github.com/BeaconCMS/beacon_live_admin/pull/208)\n  - [Visual Editor] Reset drag states when dropping, even on invalid targets - [#206](https://github.com/BeaconCMS/beacon_live_admin/pull/206)\n  - [Visual Editor] Disable interacting with iframes - [#198](https://github.com/BeaconCMS/beacon_live_admin/pull/198)\n  - Remove defunct reference to agent assigns - [#200](https://github.com/BeaconCMS/beacon_live_admin/pull/200) by @kelcecil","ref":"changelog.html#fixes"},{"type":"extras","title":"0.1.0-rc.0 (2024-08-02) - Changelog","doc":"","ref":"changelog.html#0-1-0-rc-0-2024-08-02"},{"type":"extras","title":"Enhancements - Changelog","doc":"- Media Library\n    - Upload, preview, and display image location\n    - Sorting and pagination\n  - Error Page\n  - Components\n    - Sorting and pagination\n  - Layouts\n    - Sorting and pagination\n  - Pages\n    - Visual Editor with HEEx and 2-way sync support\n    - Sorting and pagination\n  - Live Data\n  - Custom Pages\n  - Router helper `~p` to generate paths with site prefixes\n  - Content management through the `Beacon.Content` API\n  - A/B Variants\n  - TailwindCSS compiler","ref":"changelog.html#enhancements"},{"type":"extras","title":"Installation","doc":"# Installation\n\nBeacon LiveAdmin is a Phoenix LiveView application to manage running sites, allowing you to build your site by creating resources like layouts, pages, components, and more.\n\nIt runs as a library in your Phoenix LiveView application, either in a new or an existing application.\n\nBeacon LiveAdmin can be [installed along with Beacon](https://github.com/BeaconCMS/beacon/blob/main/guides/introduction/installation.md) in the same application/node or in a separated application/node if you need to isolate it for performance or security reasons.\n\nIt will find all running sites in the cluster as long as the nodes are connected to each other, which can be achieved with libs like [libcluster](https://hex.pm/packages/libcluster) or [dns_cluster](https://hex.pm/packages/dns_cluster).\n\nIf you already have a Phoenix LiveView application up and running that meet the minimum requirements for Beacon and Beacon LiveAdmin, you can directly to step 5 - adding the `:beacon_live_admin` dependency.","ref":"installation.html"},{"type":"extras","title":"Steps - Installation","doc":"1. Install Elixir v1.14 or later\n\nCheck out the official [Elixir install guide](https://elixir-lang.org/install.html) for more info.\n\n2. Update Hex\n\n  ```sh\n  mix local.hex\n  ```\n\nIf that command fails or Elixir version is outdated, please follow the [Elixir Install guide](https://elixir-lang.org/install.html) to set up your environment correctly.\n\n3. Install Phoenix v1.7 or later\n\n  ```sh\n  mix archive.install hex phx_new\n  ```\n\nCheck out the official [Phoenix install guide](https://hexdocs.pm/phoenix/installation.html) for more info.\n\n4. Generate a new Phoenix application\n\n  ```sh\n  mix phx.new --install admin\n  ```\n\nNote that BeaconLiveAdmin supports Umbrella applications as well.\n\n5. Add `:beacon_live_admin` dependency to `mix.exs`\n\n  ```diff\n  + {:beacon_live_admin, \">= 0.0.0\"},\n  ```\n\n6. Add `:beacon_live_admin` into `:import_deps` in file `.formatter.exs`\n\n  ```diff\n  - import_deps: [:ecto, :ecto_sql, :phoenix],\n  + import_deps: [:ecto, :ecto_sql, :phoenix, :beacon_live_admin],\n  ```\n\n7. Add `beacon_live_admin` to your application `router.ex` file:\n\n  ```elixir\n  use Beacon.LiveAdmin.Router # <- add this line\n\n  pipeline :browser do\n    # ...\n    # ommited for brevity\n    plug Beacon.LiveAdmin.Plug # <- add this line\n  end\n\n  # add the following scope before any beacon_site\n  scope \"/admin\" do\n    pipe_through :browser\n    beacon_live_admin \"/\"\n  end\n  ```\n\nNote that route precedence is important, make sure the there are no conflicts with other routes otherwise Beacon LiveAdmin will not work properly.\n\nFor example, if a site is mounted at `/` then you should add the admin scope before so `/admin` is handled by Beacon LiveAdmin,\notherwise Beacon will try to find a page for `/admin` defined in the site. The same may happen with other routes on your application.\n\n8. Install deps\n\n  ```sh\n  mix deps.get\n  ```","ref":"installation.html#steps"},{"type":"extras","title":"Additional Pages","doc":"# Additional Pages","ref":"additional-pages.html"},{"type":"extras","title":"Add Pages - Additional Pages","doc":"In your app router, you can mount additional pages in the `beacon_live_admin` route, for example:\n\n\n```elixir\nbeacon_live_admin(\"/admin\",\n  additional_pages: [\n    {\"/documents\", MyAppWeb.Admin.DocumentsLive.Index, :index}\n  ]\n)\n```\n\nThe format is very similar to a regular route, you must inform the path, the LiveView module and action name. In this example a page will be available at `/admin/documents`.","ref":"additional-pages.html#add-pages"},{"type":"extras","title":"Build your page - Additional Pages","doc":"Admin pages must use the `Beacon.LiveAdmin.PageBuilder` module, which provides the foundation for LiveView pages to work in the admin interface. Here's an example:\n\n```elixir\ndefmodule MyAppWeb.Admin.DocumentsLive.Index do\n  use Beacon.LiveAdmin.PageBuilder\n\n  @impl true\n  def menu_link(_prefix, _live_action), do: {:root, \"Documents\"}\n\n  @impl true\n  def mount(params, _session, socket) do\n    documents = MyApp.Documents.list()\n    {:ok, assign(socket, documents: documents)}\n  end\n\n  @impl true\n  def render(assigns) do\n    ~H\"\"\"\n    <.header>\n      Listing Documents\n    </.header>\n\n    <%-- implement your page template here --%>\n    \"\"\"\n  end\nend\n```\n\nYou'll notice the only different from a regular LiveView is the `menu_link/2` callback, which is used to define the menu item for the page.","ref":"additional-pages.html#build-your-page"},{"type":"extras","title":"Basic Auth","doc":"# Basic Auth\n\nThe Admin interface should be protected to prevent unauthorized access,\nbut Beacon doesn't provide a sign up / login system out of the box because every\nenvironment has its own requirements and workflows.\n\nTo get started quickly, you can use the basic auth on the router level which\nworks well and is safe when using SSL.","ref":"basic-auth.html"},{"type":"extras","title":"Objective - Basic Auth","doc":"Protect the admin interface with basic auth using credentials from environment variables.","ref":"basic-auth.html#objective"},{"type":"extras","title":"Prerequisites - Basic Auth","doc":"Beacon LiveAdmin is already installed and configured.","ref":"basic-auth.html#prerequisites"},{"type":"extras","title":"Router - Basic Auth","doc":"Open your router file `lib/my_app_web/router.ex` to  create a new pipeline only for the admin routes that will call the basic auth function.\n\n```elixir\ndefmodule MyAppWeb.Router do\n  use MyAppWeb, :router\n  use Beacon.LiveAdmin.Router\n\n  pipeline :browser do\n    # omitted for brevity...\n    plug Beacon.LiveAdmin.Plug\n  end\n\n  # add this pipeline\n  pipeline :require_auth do\n    plug :admin_basic_auth\n  end\n\n  scope \"/admin\" do\n    pipe_through [:browser, :require_auth] # <- add the require_auth pipeline\n    beacon_live_admin \"/\"\n  end\n\n  # rest of the router ommitted for brevity...\n\n  defp admin_basic_auth(conn, _opts) do\n    username = System.fetch_env!(\"BEACON_ADMIN_USERNAME\")\n    password = System.fetch_env!(\"BEACON_ADMIN_PASSWORD\")\n    Plug.BasicAuth.basic_auth(conn, username: username, password: password)\n  end\nend\n```","ref":"basic-auth.html#router"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.3"}}